Subject: MPC5200 + LocalPlus Bus + memcpy

From: Sascha Hauer <[email-masked]>
Date: Wed, 5 Apr 2006 13:38:26 +0200

Hi all,

I try to use jffs2 on a flash device connected to the mpc5200
LocalPlus Bus. This bus does not allow misaligned accesses.
The jffs2 code uses memcpy to copy from a word aligned address to an
odd address. The ppc memcpy implementation first copies three bytes to get
the target address word aligned, but then the source address is on an
odd address. The following word accesses on this unaligned address fail
badly.

I have fixed my problem by modifying the physmap mtd driver, but some
day someone wants to connect SRAM to the LocalPlus Bus and I guess he
will expect memcpy to work.

(BTW the arm implementation of memcpy seems to work around this problem)

Sascha